"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IO = void 0;
var logger_1 = require("../logger");
/**
 * @module IO
 * @author Jonathan Casarrubias <t:@johncasarrubias, gh:github.com/mean-expert-official>
 * @license MIT <MEAN Expert - Jonathan Casarrubias>
 * @description
 *
 * This module is created to implement IO Functionality into the LoopBack Framework.
 * This works with the SDK Builder and as a module of the FireLoop.io Framework
 **/
var IO = /** @class */ (function () {
    function IO(driver, options) {
        logger_1.RealTimeLog.log("IO server enabled using " + options.driver.name + " driver.");
        IO.driver = driver;
        IO.options = options;
        return IO;
    }
    IO.emit = function (event, message) {
        var data = typeof message === 'object' ? JSON.stringify(message) : message;
        if (IO.options.debug) {
            logger_1.RealTimeLog.log("IO Server Sending message to " + event);
            logger_1.RealTimeLog.log("Message: " + data);
        }
        IO.driver.emit(event, data);
    };
    IO.on = function (event, next) {
        IO.driver.on(event, next);
    };
    return IO;
}());
exports.IO = IO;
//# sourceMappingURL=IO.js.map